﻿Imports System
Imports System.Globalization
Imports System.Collections.Generic
Imports System.Collections.Concurrent
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Threading
Imports System.Net
Imports System.Net.Sockets
Imports System.Xml
Imports System.Reflection
Imports Microsoft.Win32
Imports RFID.Reader
Imports RFID.ReaderComm

Namespace ReadWriteTagData
    Class ReadWriteTagData
        Const DEFAULT_READER_IP_ADDRESS As String = "192.168.1.120"
        Const PORT_NUMBER As Integer = 5000
        Const maxResponseSize As Integer = 1000
        Shared reader As RFIDReader = Nothing
        Const TAG_ACCESS_PASSWORD As Integer = &H0
        Const TAG_KILL_PASSWORD As Integer = &H0
        Shared TAG_EPC As String() = {"66", "66", "66", "66", "66", "66", "66", "66", "66", "66", "66", "66"}
        Private Shared TAG_ID As String() = {"", "", "", "", "", ""}

        Public Shared Sub Main(ByVal args As String())
            Try
                Dim readerIPAddress As String = DEFAULT_READER_IP_ADDRESS
                Dim PortNumber As UInt16 = PORT_NUMBER
                Console.WriteLine("Setting up ReaderComm instance on IP address " & readerIPAddress & vbLf & vbLf & vbLf)
                Console.WriteLine("Read and Write Tags Test" & vbLf & "///////////////////////////////////////////////////////////////" & vbLf)
                reader = New RFIDReader(readerIPAddress, PortNumber)
                ReadTagData()
                UpdateSelectedTagFields()
                ReadTagData2()
                ResetTagData()
            Catch ex As Exception
                Console.WriteLine("Main: " & ex.ToString())
            End Try
        End Sub

        Private Shared Sub ReadTagData()
            Try
                Dim dataBanks As Byte() = {0, 0, 1, 2, 3}
                Dim dataBankLengths As UInt16() = {2, 2, 8, 6, 8}
                Dim dataBankAddress As UInt16() = {0, 2, 0, 0, 0}
                Dim filterBank As Byte = 1
                Dim filterAddress As UInt16 = 32
                Dim filterBitLength As UInt16 = 96
                Dim filterMask As Byte() = New Byte(11) {}
                Dim epc As String() = TAG_EPC
                Dim bytesInMask As Integer = epc.Length
                If bytesInMask > filterMask.Length Then bytesInMask = filterMask.Length

                For idx As Integer = 0 To bytesInMask - 1
                    filterMask(idx) = Byte.Parse(epc(idx), System.Globalization.NumberStyles.HexNumber)
                Next

                For idx As Integer = 0 To dataBanks.Length - 1
                    Dim errorCode As Byte = 0
                    Dim data As UInt16() = New UInt16(99) {}
                    Dim dataBank As Byte = dataBanks(idx)
                    Dim dataLength As UInt16 = dataBankLengths(idx)
                    Dim thePassword As String = ""
                    Dim accessPassword As UInt32 = &H0
                    Dim dataOk As Boolean = True
                    dataBank = dataBanks(idx)
                    If Not dataOk Then Return
                    Dim status As RFIDStatus = ReadWriteTagData.reader.ReadTagData(accessPassword, filterBank, filterAddress, filterBitLength, filterMask, dataBank, dataBankAddress(idx), dataLength, data, errorCode)

                    If status = RFIDStatus.OK Then

                        Select Case idx
                            Case 0
                                thePassword = (data(0) << 16 Or data(1)).ToString("X8")
                                Console.WriteLine("Kill Password: " & thePassword)
                            Case 1

                                thePassword = (data(0) << 16 Or data(1)).ToString("X8")
                                Console.WriteLine("Access Password: " & thePassword)
                            Case 2
                                Dim EPCFull As String = ""

                                For jdx As Integer = 2 To dataLength - 1
                                    Dim epcWord As String = data(jdx).ToString("X4")
                                    EPCFull += epcWord & " "
                                Next

                                Console.WriteLine("EPC: " & EPCFull)
                            Case 3
                                Dim tidTag As String = ""

                                For jdx As Integer = 0 To dataLength - 1
                                    Dim tidWord As String = data(jdx).ToString("X4")
                                    tidTag += tidWord & " "
                                    TAG_ID(jdx) = tidWord
                                Next

                                Console.WriteLine("Tag ID: " & tidTag)
                            Case 4
                                Dim userInfo As String = " "

                                For jdx As Integer = 0 To dataLength - 1
                                    Dim umWord As String = data(jdx).ToString("X4")
                                    userInfo += umWord & " "
                                Next

                                Console.WriteLine("User Data: " & userInfo)
                        End Select
                    Else
                        Console.WriteLine("Read Tag Data (" & dataBank.ToString() & ") failed. Error code: " & errorCode.ToString())
                    End If
                Next

            Catch ex As Exception
                Console.WriteLine("Read Tag Data: " & ex.Message)
            End Try
        End Sub

        Private Shared Sub ReadTagData2()
            Try
                Dim dataBanks As Byte() = {0, 0, 1, 2, 3}
                Dim dataBankLengths As UInt16() = {2, 2, 8, 6, 8}
                Dim dataBankAddress As UInt16() = {0, 2, 0, 0, 0}
                Dim filterBank As Byte = 1
                Dim filterAddress As UInt16 = 32
                Dim filterBitLength As UInt16 = 96
                Dim filterMask As Byte() = New Byte(11) {}
                Dim epc As String() = {"66", "66", "66", "66", "66", "66", "66", "66", "66", "66", "55", "55"}
                Dim bytesInMask As Integer = epc.Length
                If bytesInMask > filterMask.Length Then bytesInMask = filterMask.Length

                For idx As Integer = 0 To bytesInMask - 1
                    filterMask(idx) = Byte.Parse(epc(idx), System.Globalization.NumberStyles.HexNumber)
                Next

                For idx As Integer = 0 To dataBanks.Length - 1
                    Dim errorCode As Byte = 0
                    Dim data As UInt16() = New UInt16(99) {}
                    Dim dataBank As Byte = dataBanks(idx)
                    Dim dataLength As UInt16 = dataBankLengths(idx)
                    Dim thePassword As String = ""
                    Dim accessPassword As UInt32 = &H0
                    Dim dataOk As Boolean = True
                    dataBank = dataBanks(idx)
                    If Not dataOk Then Return
                    Dim status As RFIDStatus = ReadWriteTagData.reader.ReadTagData(accessPassword, filterBank, filterAddress, filterBitLength, filterMask, dataBank, dataBankAddress(idx), dataLength, data, errorCode)

                    If status = RFIDStatus.OK Then

                        Select Case idx
                            Case 0

                                thePassword = (data(0) << 16 Or data(1)).ToString("X8")
                                Console.WriteLine("Kill Password: " & thePassword)
                            Case 1
                                thePassword = (data(0) << 16 Or data(1)).ToString("X8")
                                Console.WriteLine("Access Password: " & thePassword)
                            Case 2
                                Dim EPCFull As String = ""

                                For jdx As Integer = 2 To dataLength - 1
                                    Dim epcWord As String = data(jdx).ToString("X4")
                                    EPCFull += epcWord & " "
                                Next

                                Console.WriteLine("EPC: " & EPCFull)
                            Case 3
                                Dim tidTag As String = ""

                                For jdx As Integer = 0 To dataLength - 1
                                    Dim tidWord As String = data(jdx).ToString("X4")
                                    tidTag += tidWord & " "
                                    TAG_ID(jdx) = tidWord
                                Next

                                Console.WriteLine("Tag ID: " & tidTag)
                            Case 4
                                Dim userInfo As String = " "

                                For jdx As Integer = 0 To dataLength - 1
                                    Dim umWord As String = data(jdx).ToString("X4")
                                    userInfo += umWord & " "
                                Next

                                Console.WriteLine("User Data: " & userInfo)
                        End Select
                    Else
                        Console.WriteLine("Read Tag Data (" & dataBank.ToString() & ") failed. Error code: " & errorCode.ToString())
                    End If
                Next

            Catch ex As Exception
                Console.WriteLine("Read Tag Data: " & ex.Message)
            End Try
        End Sub

        Private Shared Function UpdateSelectedTagFields() As Boolean
            Dim dataOk As Boolean = True
            Dim maskBank As Byte = &H2
            Dim maskStartAddress As UInt16 = &H0
            Dim maskLength As UInt16 = 96
            Dim mask As Byte() = New Byte(11) {}
            Dim errorCode As Byte = 0
            Dim accessPassword As UInt32 = &H0
            Dim killPassword As UInt32 = TAG_KILL_PASSWORD
            Dim accessPasswordUpdate As UInt32 = TAG_ACCESS_PASSWORD

            For idx As Integer = 0 To maskLength / 16 - 1
                Dim tidWord As UInt16 = 0
                tidWord = Convert.ToUInt16(TAG_ID(idx), 16)

                mask(idx * 2) = CByte((tidWord >> 8) And &HFF)
                mask(idx * 2 + 1) = CByte((tidWord And &HFF))
            Next

            Dim dataFieldNames As String() = {"Kill Password", "Access Password", "EPC Data", "User Data"}
            Dim dataBanks As Byte() = {0, 0, 1, 3}
            Dim dataBankLengths As UInt16() = {2, 2, 6, 8}
            Dim dataBankAddresses As UInt16() = {0, 2, 2, 0}
            Dim dataBank As Byte
            Dim dataBankAddress As UInt16
            Dim dataLength As UInt16
            Dim data As UInt16() = New UInt16(7) {}
            Dim attempts As Integer = 0

            For fieldIndex As Integer = 0 To dataBanks.Length - 1
                dataOk = True
                dataBank = dataBanks(fieldIndex)
                dataBankAddress = dataBankAddresses(fieldIndex)
                dataLength = dataBankLengths(fieldIndex)

                Select Case fieldIndex
                    Case 0
                        killPassword = killPassword + 1

                        For idx As Integer = 0 To 2 - 1
                            data(idx) = CUShort((killPassword >> (1 - idx) * 16) And &HFFFF)
                        Next

                    Case 1
                        accessPasswordUpdate = accessPasswordUpdate + 1

                        For idx As Integer = 0 To 2 - 1
                            data(idx) = CUShort((accessPasswordUpdate >> (1 - idx) * 16) And &HFFFF)
                        Next

                    Case 2
                        Dim epcParts As String() = {"6666", "6666", "6666", "6666", "6666", "5555"}

                        For idx As Integer = 0 To dataLength - 1
                            Dim fldWord As UInt16 = Convert.ToUInt16(epcParts(idx), 16)
                            data(idx) = fldWord
                        Next

                    Case 3
                        Dim userData As String() = {"0000", "0000", "0000", "0000", "0000", "0000", "0000", "0006"}

                        For idx As Integer = 0 To dataLength - 1
                            Dim fldWord As UInt16 = Convert.ToUInt16(userData(idx), 16)
                            data(idx) = fldWord
                        Next
                End Select

                Dim status As RFIDStatus = ReadWriteTagData.reader.WriteTagData(accessPassword, maskBank, maskStartAddress, maskLength, mask, dataBank, dataBankAddress, dataLength, data, errorCode)

                If errorCode = 3 OrElse errorCode = 1 AndAlso attempts <= 1 Then
                    Console.WriteLine("Error updating data retrying ... ")
                    fieldIndex -= 1
                    attempts += 1
                End If
            Next

            Console.WriteLine(vbLf & "Tag data written ..." & vbLf & vbLf)
            Return dataOk
        End Function

        Private Shared Function ResetTagData() As Boolean
            Dim dataOk As Boolean = True
            Dim maskBank As Byte = &H2
            Dim maskStartAddress As UInt16 = &H0
            Dim maskLength As UInt16 = 96
            Dim mask As Byte() = New Byte(11) {}
            Dim errorCode As Byte = 0
            Dim accessPassword As UInt32 = &H0
            Dim killPassword As UInt32 = TAG_KILL_PASSWORD
            Dim accessPasswordUpdate As UInt32 = TAG_ACCESS_PASSWORD

            For idx As Integer = 0 To maskLength / 16 - 1
                Dim tidWord As UInt16 = 0
                tidWord = Convert.ToUInt16(TAG_ID(idx), 16)
                mask(idx * 2) = CByte((tidWord >> 8) And &HFF)


                mask(idx * 2 + 1) = CByte((tidWord And &HFF))
            Next

            Dim dataFieldNames As String() = {"Kill Password", "Access Password", "EPC Data", "User Data"}
            Dim dataBanks As Byte() = {0, 0, 1, 3}
            Dim dataBankLengths As UInt16() = {2, 2, 6, 8}
            Dim dataBankAddresses As UInt16() = {0, 2, 2, 0}
            Dim dataBank As Byte
            Dim dataBankAddress As UInt16
            Dim dataLength As UInt16
            Dim data As UInt16() = New UInt16(7) {}
            Dim attempts As Integer = 0

            For fieldIndex As Integer = 0 To dataBanks.Length - 1
                dataOk = True
                dataBank = dataBanks(fieldIndex)
                dataBankAddress = dataBankAddresses(fieldIndex)
                dataLength = dataBankLengths(fieldIndex)

                Select Case fieldIndex
                    Case 0

                        For idx As Integer = 0 To 2 - 1
                            data(idx) = CUShort((killPassword >> (1 - idx) * 16) And &HFFFF)

                        Next

                    Case 1

                        For idx As Integer = 0 To 2 - 1
                            data(idx) = CUShort((accessPasswordUpdate >> (1 - idx) * 16) And &HFFFF)
                        Next

                    Case 2
                        Dim OrignalEPC As String() = TAG_EPC

                        Dim epcParts As String() = {OrignalEPC(0) + OrignalEPC(1), OrignalEPC(2) + OrignalEPC(3),
                                                    OrignalEPC(4) + OrignalEPC(5), OrignalEPC(6) + OrignalEPC(7),
                                                    OrignalEPC(8) + OrignalEPC(9), OrignalEPC(10) + OrignalEPC(11)}

                        For idx As Integer = 0 To dataLength - 1
                            Dim fldWord As UInt16 = Convert.ToUInt16(epcParts(idx), 16)
                            data(idx) = fldWord
                        Next

                    Case 3
                        Dim userData As String() = {"0000", "0000", "0000", "0000", "0000", "0000", "0000", "0004"}

                        For idx As Integer = 0 To dataLength - 1
                            Dim fldWord As UInt16 = Convert.ToUInt16(userData(idx), 16)
                            data(idx) = fldWord
                        Next
                End Select

                Dim status As RFIDStatus = ReadWriteTagData.reader.WriteTagData(accessPassword, maskBank, maskStartAddress, maskLength, mask, dataBank, dataBankAddress, dataLength, data, errorCode)

                If errorCode = 3 OrElse errorCode = 1 AndAlso attempts <= 1 Then
                    Console.WriteLine("Error updating data retrying ... ")
                    fieldIndex -= 1
                    attempts += 1
                End If
            Next

            Console.WriteLine(vbLf & "Tag data Reset ... " & vbLf & " ")
            Return dataOk
        End Function
    End Class
End Namespace
