﻿Imports System
Imports System.Globalization
Imports System.Collections.Generic
Imports System.Collections.Concurrent
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Threading
Imports System.Net
Imports System.Net.Sockets
Imports System.Xml
Imports System.Reflection
Imports Microsoft.Win32
Imports RFID.Reader
Imports RFID.ReaderComm

Namespace ReadingTags
    Class ReadingTags
        Shared DEFAULT_READER_IP_ADDRESS As String = "192.168.1.120"
        Shared PORT_NUMBER As UInt16 = 5000
        Public Shared reader As RFIDReader = Nothing
        Public Shared reading As Boolean = False

        Public Shared Sub Main(ByVal args As String())
            Dim readerIPAddress As String = DEFAULT_READER_IP_ADDRESS
            Dim PortNumber As UInt16 = PORT_NUMBER
            Console.WriteLine("Setting up ReaderComm instance on IP Address " & readerIPAddress)
            reader = New RFIDReader(readerIPAddress, PortNumber, AddressOf PrintInfo)
            Console.WriteLine("Getting Reader Info" & vbLf)
            ReaderInfo()
            ReadTest()
        End Sub

        Public Shared Sub ReaderInfo()
            Dim id As String = ""
            Dim status As RFIDStatus = ReadingTags.reader.GetHardwareId(id)
            Console.WriteLine("SensArray Hardware Id: " & id)
        End Sub

        Public Shared Sub ReadTest()
            Console.WriteLine("Starting Continuous Read ...")
            ReadingTags.reading = True
            ReadingTags.reader.StartContinuousRead()
            Thread.Sleep(20000)
            Console.WriteLine("Stopping Continuous Read ...")
            ReadingTags.reader.StopContinuousRead()

            While ReadingTags.reading
                Thread.Sleep(10)
            End While
        End Sub

        Public Shared Sub PrintInfo(ByVal readInfo As TagReadInfo)
            If readInfo.status = RFIDStatus.OK Then
                Console.WriteLine(readInfo.EPC)
            ElseIf readInfo.status = RFIDStatus.DONE Then
                ReadingTags.reading = False
                Console.WriteLine("Received Stop Response")
            End If
        End Sub
    End Class
End Namespace

