﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports RFID.Reader
Imports RFID.ReaderComm
Imports System.Threading

Namespace SetEPCFilter
    Class SetEPCFilter
        Const DEFAULT_READER_IP_ADDRESS As String = "192.168.1.120"
        Const PORT_NUMBER As UInt16 = 5000
        Const maxResoponseSize As Integer = 1000
        Shared TAG_EPC_FILTER As String() = {"66", "66", "66", "66", "66", "66"}
        Public Shared reader As RFIDReader = Nothing
        Public Shared reading As Boolean = False

        Public Shared Sub Main(ByVal args As String())
            Dim readerIPAddress As String = DEFAULT_READER_IP_ADDRESS
            Dim PortNumber As UInt16 = PORT_NUMBER
            Console.WriteLine("Setting up ReaderComm instance on IP Address " & readerIPAddress)
            reader = New RFIDReader(readerIPAddress, PortNumber, AddressOf PrintInfo)
            SetEPCFilter.TagReadEPCFilter(0)
            SetEPCFilter.ReadTest()
            SetEPCFilter.reader.ClearInventoryFilter(True)
        End Sub

        Public Shared Sub TagReadEPCFilter(ByVal startAddress As Integer)

            Dim tagEPCFilter As String() = TAG_EPC_FILTER
                Dim filterBank As Byte = 1
                Dim filterAddress As UInt16 = CUShort((32 + startAddress))
                Dim filterBitLength As UInt16 = CUShort(tagEPCFilter.Length)
                Dim filterMask As Byte() = New Byte(11) {}
                Dim bytesInMask As Integer = tagEPCFilter.Length
                If bytesInMask > filterMask.Length Then bytesInMask = filterMask.Length

                For idx As Integer = 0 To bytesInMask - 1
                    filterMask(idx) = Byte.Parse(tagEPCFilter(idx), System.Globalization.NumberStyles.HexNumber)
                Next

                SetEPCFilter.reader.SetInventoryFilter(filterBank, filterAddress, filterBitLength, filterMask, True)

        End Sub

        Public Shared Sub ReaderInfo()
            Dim id As String = ""
            Dim status As RFIDStatus = SetEPCFilter.reader.GetHardwareId(id)
            Console.WriteLine("SensArray Hardware Id: " & id)
        End Sub

        Public Shared Sub ReadTest()
            Console.WriteLine("Starting Continuous Read ...")
            SetEPCFilter.reading = True
            SetEPCFilter.reader.StartContinuousRead()
            Thread.Sleep(20000)
            Console.WriteLine("Stopping Continuous Read ...")
            SetEPCFilter.reader.StopContinuousRead()

            While SetEPCFilter.reading
                Thread.Sleep(10)
            End While
        End Sub

        Public Shared Sub PrintInfo(ByVal readInfo As TagReadInfo)
            If readInfo.status = RFIDStatus.OK Then
                Console.WriteLine(readInfo.EPC)
            ElseIf readInfo.status = RFIDStatus.DONE Then
                SetEPCFilter.reading = False
                Console.WriteLine("Received Stop Response")
            End If
        End Sub
    End Class
End Namespace
